Scriptname Animless_Attack_Proc_Script extends ActiveMagicEffect  

Perk Property ShieldWallFirst Auto
Perk Property ShieldWallSecond Auto
Perk Property ShieldWallThird Auto
Perk Property ShieldWallFourth Auto
Perk Property ShieldWallFifth Auto

Actor Target
Actor Caster

Float Property MeleeDamageBase = 5.0 Auto
Float Property PowerAttackDamage = 1.75 Auto
Int Property CritChancePercentage = 5 Auto
Float Property CritDamage = 2.0 Auto

Bool Property IsPowerAttack = False Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	
	Target = akTarget
	Caster = akCaster
	
	If !Target.IsDead()	

		Float OneHandModAV = Caster.GetActorValue("OnehandedMod")
		Float OneHandPowerModAV = Caster.GetActorValue("OnehandedPowerMod")

		Float TwoHandModAV = Caster.GetActorValue("TwohandedMod")
		Float TwoHandPowerModAV = Caster.GetActorValue("TwohandedPowerMod")

		Float ArmorScalingFactor = Game.GetGameSettingFloat("fArmorScalingFactor")
		Float TargetDamageResistAV = Target.GetActorValue("DamageResist")
		Float MeleeResistDamage = (100 - ArmorScalingFactor*TargetDamageResistAV)/100

		Float PowerAttackDamageMod
		If !IsPowerAttack
			PowerAttackDamageMod = 1.0
		Else
			PowerAttackDamageMod = PowerAttackDamage
		EndIf

		Float CritDamageMod
		Float CritRoll = Utility.RandomInt(0, 100)
		If CritRoll > CritChancePercentage
			CritDamageMod = 1.0
		Else
			CritDamageMod = CritDamage
		EndIf

		Float MeleeDamageSubtotal = MeleeDamageBase*(1+((OneHandModAV+TwoHandModAV)/2)*0.01)*(1+((OneHandPowerModAV+TwoHandPowerModAV)/2)*0.01)*MeleeResistDamage*PowerAttackDamageMod*CritDamageMod

		If (Target As Actor).GetAnimationVariableBool("Isblocking") == True
		
				Float TargetBlockAV = Target.GetActorValue("Block")
				Armor TargetsShield = Target.GetEquippedShield()
				
				Float TargetBlockBase
				Float TotalDamage

				If Target.GetEquippedShield() == None
					TargetBlockBase = 30 + 0.2*MeleeDamageBase*(1 + TargetBlockAV*0.015)
				Else
					TargetBlockBase = 45 + 0.2*(TargetsShield.GetArmorRating()) * (1 + TargetBlockAV*0.015)
				EndIf
								
				Float BlockModAV = Target.GetActorValue("BlockModAV")
				Float BlockPowerModAV = Target.GetActorValue("BlockPowerModAV")
				
				Float ShieldWallBlockMult
				
				If Target.HasPerk(ShieldWallFifth)
					ShieldWallBlockMult = 1.4				
				ElseIf Target.HasPerk(ShieldWallFourth)
					ShieldWallBlockMult = 1.35
				ElseIf Target.HasPerk(ShieldWallThird)
					ShieldWallBlockMult = 1.3
				ElseIf Target.HasPerk(ShieldWallSecond)
					ShieldWallBlockMult = 1.25
				ElseIf Target.HasPerk(ShieldWallFirst)
					ShieldWallBlockMult = 1.2
				Else
					ShieldWallBlockMult = 1.0
				EndIf

				Float TotalBlockModifier = (100 - (TargetBlockBase*(1+BlockModAV*0.01)*(1+BlockPowerModAV*0.01)*ShieldWallBlockMult))/100 			; needs a modifier for damage blocked, but I'm not sure about the formula for that. https://en.uesp.net/wiki/Skyrim:Block
				
				TotalDamage = (MeleeDamageSubtotal*TotalBlockModifier)
				
				Target.DamageActorValue("Health", TotalDamage)
			
;				debug.Notification("" + TotalDamage + " damage has been dealt.")
		Else
		
			Target.DamageActorValue("Health", MeleeDamageSubtotal)
;			debug.Notification("" + MeleeDamageSubtotal + " damage has been dealt.")		
		EndIf
	
	EndIf
	
EndEvent